diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/CavesLargeFeature.java b/game/core/src/main/java/net/minecraft/core/world/generate/CavesLargeFeature.java
index 28edfe195..8595a5bbe 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/CavesLargeFeature.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/CavesLargeFeature.java
@@ -8,6 +8,7 @@ import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.chunk.ChunkSection;
 import net.minecraft.core.world.generate.chunk.ChunkGeneratorResult;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
@@ -16,8 +17,8 @@ public class CavesLargeFeature extends LargeFeature {
     private final int maxY;
 
     public CavesLargeFeature() {
-        minY = 0;
-        maxY = Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y;
+        this.minY = 0;
+        this.maxY = Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y;
     }
 
     public CavesLargeFeature(int minY, int maxY) {
@@ -25,29 +26,29 @@ public class CavesLargeFeature extends LargeFeature {
         this.maxY = maxY;
     }
 
-    protected void generateHubRoom(long seed, int baseChunkX, int baseChunkZ, ChunkGeneratorResult result, double blockX, double blockY, double blockZ) {
-        generateCave(seed, baseChunkX, baseChunkZ, result, blockX, blockY, blockZ, 1.0F + rand.nextFloat() * 6F, 0.0F, 0.0F, -1, -1, 0.5D);
+    protected void generateHubRoom(@NotNull World world, @NotNull Random random, long seed, int baseChunkX, int baseChunkZ, @NotNull ChunkGeneratorResult result, double blockX, double blockY, double blockZ) {
+        generateCave(world, random, seed, baseChunkX, baseChunkZ, result, blockX, blockY, blockZ, 1.0F + random.nextFloat() * 6F, 0.0F, 0.0F, -1, -1, 0.5D);
     }
 
-    protected void generateCave(long seed, int baseChunkX, int baseChunkZ, ChunkGeneratorResult result, double blockX, double blockY,
+    protected void generateCave(@NotNull World world, @NotNull Random random, long seed, int baseChunkX, int baseChunkZ, @NotNull ChunkGeneratorResult result, double blockX, double blockY,
                                 double blockZ, float initialRadius, float yRot, float xRot, int startPos, int endPos,
                                 double heightMod) {
         double chunkMiddleX = baseChunkX * Chunk.CHUNK_SIZE_X + Chunk.CHUNK_SIZE_X / 2;
         double chunkMiddleZ = baseChunkZ * Chunk.CHUNK_SIZE_Z + Chunk.CHUNK_SIZE_Z / 2;
         float rotHorOffset = 0.0F;
         float rotVerOffset = 0.0F;
-        Random random = new Random(seed);
+        Random r = new Random(seed);
         if (endPos <= 0) {
-            int maxLength = radiusChunk * 16 - 16;
-            endPos = maxLength - random.nextInt(maxLength / 4);
+            int maxLength = this.getRadiusChunk() * 16 - 16;
+            endPos = maxLength - r.nextInt(maxLength / 4);
         }
         boolean noBranches = false;
         if (startPos == -1) {
             startPos = endPos / 2;
             noBranches = true;
         }
-        int branchPos = random.nextInt(endPos / 2) + endPos / 4;
-        boolean sharpRotVer = random.nextInt(6) == 0;
+        int branchPos = r.nextInt(endPos / 2) + endPos / 4;
+        boolean sharpRotVer = r.nextInt(6) == 0;
         for (; startPos < endPos; startPos++) {
             double width = 1.5D + (MathHelper.sin((startPos * MathHelper.PI) / endPos) * initialRadius * 1.0F);
             double height = width * heightMod;
@@ -65,18 +66,18 @@ public class CavesLargeFeature extends LargeFeature {
             yRot += rotHorOffset * 0.1F;
             rotVerOffset *= 0.9F;
             rotHorOffset *= 0.75F;
-            rotVerOffset += (random.nextFloat() - random.nextFloat()) * random.nextFloat() * 2.0F;
-            rotHorOffset += (random.nextFloat() - random.nextFloat()) * random.nextFloat() * 4F;
+            rotVerOffset += (r.nextFloat() - r.nextFloat()) * r.nextFloat() * 2.0F;
+            rotHorOffset += (r.nextFloat() - r.nextFloat()) * r.nextFloat() * 4F;
 
             // Do adjacent branches if necessary
             if (!noBranches && startPos == branchPos && initialRadius > 1.0F) {
-                generateCave(random.nextLong(), baseChunkX, baseChunkZ, result, blockX, blockY, blockZ, random.nextFloat() * 0.5F + 0.5F, yRot - MathHelper.PI / 2F, xRot / 3F, startPos, endPos, 1.0D);
-                generateCave(random.nextLong(), baseChunkX, baseChunkZ, result, blockX, blockY, blockZ, random.nextFloat() * 0.5F + 0.5F, yRot + MathHelper.PI / 2F, xRot / 3F, startPos, endPos, 1.0D);
+                generateCave(world, random, r.nextLong(), baseChunkX, baseChunkZ, result, blockX, blockY, blockZ, r.nextFloat() * 0.5F + 0.5F, yRot - MathHelper.PI / 2F, xRot / 3F, startPos, endPos, 1.0D);
+                generateCave(world, random, r.nextLong(), baseChunkX, baseChunkZ, result, blockX, blockY, blockZ, r.nextFloat() * 0.5F + 0.5F, yRot + MathHelper.PI / 2F, xRot / 3F, startPos, endPos, 1.0D);
                 return;
             }
 
             // Randomly skip a section
-            if (!noBranches && random.nextInt(4) == 0) {
+            if (!noBranches && r.nextInt(4) == 0) {
                 continue;
             }
 
@@ -119,7 +120,7 @@ public class CavesLargeFeature extends LargeFeature {
             }
 
             // Check if we've hit the ocean, and if so, stop generating
-            if (worldObj.getWorldType().getOceanBlockId() != 0) {
+            if (world.getWorldType().getOceanBlockId() != 0) {
                 boolean hasHitOcean = false;
                 for (int x = minX; !hasHitOcean && x < maxX; x++) {
                     for (int z = minZ; !hasHitOcean && z < maxZ; z++) {
@@ -129,7 +130,7 @@ public class CavesLargeFeature extends LargeFeature {
                             if (y < this.minY || y >= this.maxY) {
                                 continue;
                             }
-                            if (blockId == worldObj.getWorldType().getOceanBlockId()) {
+                            if (blockId == world.getWorldType().getOceanBlockId()) {
                                 hasHitOcean = true;
                             }
                             if (y != minY - 1 && x != minX && x != maxX - 1 && z != minZ && z != maxZ - 1) {
@@ -172,7 +173,7 @@ public class CavesLargeFeature extends LargeFeature {
                                     result.setBlock(x, yIndex, z, 0);
 
                                     if (replaceTopBlock) {
-                                        Biome biome = worldObj.getBlockBiome(x, yIndex - 1, z);
+                                        Biome biome = world.getBlockBiome(x, yIndex - 1, z);
                                         int topBlockId = biome.topBlock;
                                         int fillBlockId = biome.fillerBlock;
                                         int id = result.getBlock(x, yIndex - 1, z);
@@ -196,29 +197,29 @@ public class CavesLargeFeature extends LargeFeature {
     }
 
     @Override
-    protected void doGeneration(World world, int chunkX, int chunkZ, int baseChunkX, int baseChunkZ, ChunkGeneratorResult result) {
-        int cavesToGenerate = rand.nextInt(rand.nextInt(rand.nextInt(40) + 1) + 1);
-        if (rand.nextInt(15) != 0) {
+    protected void doGeneration(@NotNull World world, @NotNull Random random, int chunkX, int chunkZ, int baseChunkX, int baseChunkZ, @NotNull ChunkGeneratorResult result) {
+        int cavesToGenerate = random.nextInt(random.nextInt(random.nextInt(40) + 1) + 1);
+        if (random.nextInt(15) != 0) {
             cavesToGenerate = 0;
         }
 
-        final int yRange = maxY - minY;
+        final int yRange = this.maxY - this.minY;
 
         for (int i = 0; i < cavesToGenerate; i++) {
-            double blockX = chunkX * Chunk.CHUNK_SIZE_X + rand.nextInt(Chunk.CHUNK_SIZE_X);
-            double blockY = minY + rand.nextInt(rand.nextInt(yRange - (ChunkSection.SECTION_SIZE_Y / 2)) + (ChunkSection.SECTION_SIZE_Y / 2));
-            double blockZ = chunkZ * Chunk.CHUNK_SIZE_Z + rand.nextInt(Chunk.CHUNK_SIZE_Z);
+            double blockX = chunkX * Chunk.CHUNK_SIZE_X + random.nextInt(Chunk.CHUNK_SIZE_X);
+            double blockY = this.minY + random.nextInt(random.nextInt(yRange - (ChunkSection.SECTION_SIZE_Y / 2)) + (ChunkSection.SECTION_SIZE_Y / 2));
+            double blockZ = chunkZ * Chunk.CHUNK_SIZE_Z + random.nextInt(Chunk.CHUNK_SIZE_Z);
 
             int numBranches = 1;
-            if (rand.nextInt(4) == 0) {
-                generateHubRoom(rand.nextLong(), baseChunkX, baseChunkZ, result, blockX, blockY, blockZ);
-                numBranches += rand.nextInt(4);
+            if (random.nextInt(4) == 0) {
+                generateHubRoom(world, random, random.nextLong(), baseChunkX, baseChunkZ, result, blockX, blockY, blockZ);
+                numBranches += random.nextInt(4);
             }
             for (int l1 = 0; l1 < numBranches; l1++) {
-                float yRot = rand.nextFloat() * MathHelper.PI * 2.0F; // 0 - 2Pi
-                float xRot = ((rand.nextFloat() - 0.5F) * 2.0F) / 8F; // -0.125 - 0.125
-                float initialRadius = rand.nextFloat() * 2.0F + rand.nextFloat(); // 0 - 3
-                generateCave(rand.nextLong(), baseChunkX, baseChunkZ, result, blockX, blockY, blockZ, initialRadius, yRot, xRot, 0, 0, 1.0f);
+                float yRot = random.nextFloat() * MathHelper.PI * 2.0F; // 0 - 2Pi
+                float xRot = ((random.nextFloat() - 0.5F) * 2.0F) / 8F; // -0.125 - 0.125
+                float initialRadius = random.nextFloat() * 2.0F + random.nextFloat(); // 0 - 3
+                generateCave(world, random, random.nextLong(), baseChunkX, baseChunkZ, result, blockX, blockY, blockZ, initialRadius, yRot, xRot, 0, 0, 1.0f);
             }
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/LargeFeature.java b/game/core/src/main/java/net/minecraft/core/world/generate/LargeFeature.java
index 18434c87f..05722cd35 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/LargeFeature.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/LargeFeature.java
@@ -2,40 +2,32 @@ package net.minecraft.core.world.generate;
 
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.generate.chunk.ChunkGeneratorResult;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
-public class LargeFeature
-{
-
-    public LargeFeature()
-    {
-        radiusChunk = 8;
+public class LargeFeature {
+    public LargeFeature() {
     }
 
-    public void generate(World world, int baseChunkX, int baseChunkZ, ChunkGeneratorResult result)
-    {
-        int radius = radiusChunk;
-        rand.setSeed(world.getRandomSeed());
-        worldObj = world;
+    public void generate(@NotNull World world, int baseChunkX, int baseChunkZ, @NotNull ChunkGeneratorResult result) {
+        int radius = getRadiusChunk();
+        Random rand = new Random(world.getRandomSeed());
         long randX = (rand.nextLong() / 2L) * 2L + 1L;
         long randZ = (rand.nextLong() / 2L) * 2L + 1L;
-        for(int chunkX = baseChunkX - radius; chunkX <= baseChunkX + radius; chunkX++)
-        {
-            for(int chunkZ = baseChunkZ - radius; chunkZ <= baseChunkZ + radius; chunkZ++)
-            {
-                rand.setSeed((long)chunkX * randX + (long)chunkZ * randZ ^ world.getRandomSeed());
-                doGeneration(world, chunkX, chunkZ, baseChunkX, baseChunkZ, result);
+        for (int chunkX = baseChunkX - radius; chunkX <= baseChunkX + radius; chunkX++) {
+            for (int chunkZ = baseChunkZ - radius; chunkZ <= baseChunkZ + radius; chunkZ++) {
+                rand.setSeed((long) chunkX * randX + (long) chunkZ * randZ ^ world.getRandomSeed());
+                doGeneration(world, rand, chunkX, chunkZ, baseChunkX, baseChunkZ, result);
             }
 
         }
     }
 
-    protected void doGeneration(World world, int chunkX, int chunkZ, int baseChunkX, int baseChunkZ, ChunkGeneratorResult result)
-    {
+    protected void doGeneration(@NotNull World world, @NotNull Random random, int chunkX, int chunkZ, int baseChunkX, int baseChunkZ, @NotNull ChunkGeneratorResult result) {
     }
 
-    protected int radiusChunk;
-    protected static Random rand = new Random();
-    protected World worldObj;
+    public int getRadiusChunk() {
+        return 8;
+    }
 }
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/NetherBonesLargeFeature.java b/game/core/src/main/java/net/minecraft/core/world/generate/NetherBonesLargeFeature.java
index 4627c0df3..4d5881d00 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/NetherBonesLargeFeature.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/NetherBonesLargeFeature.java
@@ -1,15 +1,13 @@
 package net.minecraft.core.world.generate;
 
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.chunk.ChunkSection;
 import net.minecraft.core.world.generate.chunk.ChunkGeneratorResult;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
@@ -18,8 +16,8 @@ public class NetherBonesLargeFeature extends LargeFeature {
     private final int maxY;
 
     public NetherBonesLargeFeature() {
-        minY = 0;
-        maxY = Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y;
+        this.minY = 0;
+        this.maxY = Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y;
     }
 
     public NetherBonesLargeFeature(int minY, int maxY) {
@@ -27,29 +25,29 @@ public class NetherBonesLargeFeature extends LargeFeature {
         this.maxY = maxY;
     }
 
-    protected void generateHubRoom(long seed, int baseChunkX, int baseChunkZ, ChunkGeneratorResult result, double blockX, double blockY, double blockZ) {
-        generateCave(seed, baseChunkX, baseChunkZ, result, blockX, blockY, blockZ, 1.0F + rand.nextFloat() * 6F, 0.0F, 0.0F, -1, -1, 0.5D);
+    protected void generateHubRoom(@NotNull World world, @NotNull Random random, long seed, int baseChunkX, int baseChunkZ, ChunkGeneratorResult result, double blockX, double blockY, double blockZ) {
+        generateCave(world, random, seed, baseChunkX, baseChunkZ, result, blockX, blockY, blockZ, 1.0F + random.nextFloat() * 6F, 0.0F, 0.0F, -1, -1, 0.5D);
     }
 
-    protected void generateCave(long seed, int baseChunkX, int baseChunkZ, ChunkGeneratorResult result, double blockX, double blockY,
+    protected void generateCave(@NotNull World world, @NotNull Random random, long seed, int baseChunkX, int baseChunkZ, @NotNull ChunkGeneratorResult result, double blockX, double blockY,
                                 double blockZ, float initialRadius, float yRot, float xRot, int startPos, int endPos,
                                 double heightMod) {
         double chunkMiddleX = baseChunkX * Chunk.CHUNK_SIZE_X + Chunk.CHUNK_SIZE_X / 2;
         double chunkMiddleZ = baseChunkZ * Chunk.CHUNK_SIZE_Z + Chunk.CHUNK_SIZE_Z / 2;
         float rotHorOffset = 0.0F;
         float rotVerOffset = 0.0F;
-        Random random = new Random(seed);
+        Random r = new Random(seed);
         if (endPos <= 0) {
-            int maxLength = radiusChunk * 16 - 16;
-            endPos = maxLength - random.nextInt(maxLength / 4);
+            int maxLength = getRadiusChunk() * 16 - 16;
+            endPos = maxLength - r.nextInt(maxLength / 4);
         }
         boolean noBranches = false;
         if (startPos == -1) {
             startPos = endPos / 2;
             noBranches = true;
         }
-        boolean reversed = random.nextBoolean();
-        int branchPos = random.nextInt(endPos / 2) + endPos / 4;
+        boolean reversed = r.nextBoolean();
+        int branchPos = r.nextInt(endPos / 2) + endPos / 4;
         for (; startPos < endPos; startPos++) {
             double width = 1.5D + (MathHelper.sin((startPos * MathHelper.PI) / endPos) * initialRadius * 1.0F);
             double height = width * heightMod;
@@ -71,11 +69,11 @@ public class NetherBonesLargeFeature extends LargeFeature {
 //            rotHorOffset += (random.nextFloat() - random.nextFloat()) * random.nextFloat() * 4F;
 
             // Do adjacent branches if necessary
-            if (false && !noBranches && startPos == branchPos && initialRadius > 1.0F) {
-                generateCave(random.nextLong(), baseChunkX, baseChunkZ, result, blockX, blockY, blockZ, random.nextFloat() * 0.5F + 0.5F, yRot - MathHelper.PI / 2F, xRot / 3F, startPos, endPos, 1.0D);
-                generateCave(random.nextLong(), baseChunkX, baseChunkZ, result, blockX, blockY, blockZ, random.nextFloat() * 0.5F + 0.5F, yRot + MathHelper.PI / 2F, xRot / 3F, startPos, endPos, 1.0D);
-                return;
-            }
+//            if (false) {
+//                generateCave(world, random.nextLong(), baseChunkX, baseChunkZ, result, blockX, blockY, blockZ, random.nextFloat() * 0.5F + 0.5F, yRot - MathHelper.PI / 2F, xRot / 3F, startPos, endPos, 1.0D);
+//                generateCave(world, random.nextLong(), baseChunkX, baseChunkZ, result, blockX, blockY, blockZ, random.nextFloat() * 0.5F + 0.5F, yRot + MathHelper.PI / 2F, xRot / 3F, startPos, endPos, 1.0D);
+//                return;
+//            }
 
             // Check if we've gone far enough, and stop if so
             double dxFromMiddle = blockX - chunkMiddleX;
@@ -150,27 +148,27 @@ public class NetherBonesLargeFeature extends LargeFeature {
     }
 
     @Override
-    protected void doGeneration(World world, int chunkX, int chunkZ, int baseChunkX, int baseChunkZ, ChunkGeneratorResult result) {
+    protected void doGeneration(@NotNull World world, @NotNull Random random, int chunkX, int chunkZ, int baseChunkX, int baseChunkZ, @NotNull ChunkGeneratorResult result) {
         if (world.getBlockBiome(chunkX * Chunk.CHUNK_SIZE_X, 0, chunkZ * Chunk.CHUNK_SIZE_Z) != Biomes.NETHER_BONEYARD) {
             return;
         }
 
-        int cavesToGenerate = rand.nextInt(rand.nextInt(rand.nextInt(10) + 1) + 1);
+        int cavesToGenerate = random.nextInt(random.nextInt(random.nextInt(10) + 1) + 1);
 //        if (rand.nextInt(12) != 0) {
 //            cavesToGenerate = 0;
 //        }
 
-        final int yRange = maxY - minY;
+        final int yRange = this.maxY - this.minY;
 
         for (int i = 0; i < cavesToGenerate; i++) {
-            double blockX = chunkX * Chunk.CHUNK_SIZE_X + rand.nextInt(Chunk.CHUNK_SIZE_X);
-            double blockY = minY + rand.nextInt(rand.nextInt(yRange - (ChunkSection.SECTION_SIZE_Y / 2)) + (ChunkSection.SECTION_SIZE_Y / 2));
-            double blockZ = chunkZ * Chunk.CHUNK_SIZE_Z + rand.nextInt(Chunk.CHUNK_SIZE_Z);
-
-            float yRot = rand.nextFloat() * MathHelper.PI * 2.0F; // 0 - 2Pi
-            float xRot = ((rand.nextFloat() - 0.5F) * 2.0F) / 8F; // -0.125 - 0.125
-            float initialRadius = rand.nextFloat() + rand.nextFloat(); // 0 - 3
-            generateCave(rand.nextLong(), baseChunkX, baseChunkZ, result, blockX, blockY, blockZ, initialRadius, yRot, xRot, 0, 0, 1.0f);
+            double blockX = chunkX * Chunk.CHUNK_SIZE_X + random.nextInt(Chunk.CHUNK_SIZE_X);
+            double blockY = this.minY + random.nextInt(random.nextInt(yRange - (ChunkSection.SECTION_SIZE_Y / 2)) + (ChunkSection.SECTION_SIZE_Y / 2));
+            double blockZ = chunkZ * Chunk.CHUNK_SIZE_Z + random.nextInt(Chunk.CHUNK_SIZE_Z);
+
+            float yRot = random.nextFloat() * MathHelper.PI * 2.0F; // 0 - 2Pi
+            float xRot = ((random.nextFloat() - 0.5F) * 2.0F) / 8F; // -0.125 - 0.125
+            float initialRadius = random.nextFloat() + random.nextFloat(); // 0 - 3
+            generateCave(world, random, random.nextLong(), baseChunkX, baseChunkZ, result, blockX, blockY, blockZ, initialRadius, yRot, xRot, 0, 0, 1.0f);
         }
     }
 }
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/RetroCavesLargeFeature.java b/game/core/src/main/java/net/minecraft/core/world/generate/RetroCavesLargeFeature.java
index 90928c9f6..1344d5d89 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/RetroCavesLargeFeature.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/RetroCavesLargeFeature.java
@@ -8,11 +8,11 @@ import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.chunk.ChunkSection;
 import net.minecraft.core.world.generate.chunk.ChunkGeneratorResult;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
 public class RetroCavesLargeFeature extends LargeFeature {
-    private Random rand;
     private final int minY;
     private final int maxY;
 
@@ -23,51 +23,46 @@ public class RetroCavesLargeFeature extends LargeFeature {
     public RetroCavesLargeFeature(int minY, int maxY) {
         this.minY = minY;
         this.maxY = maxY;
-        this.rand = new Random();
     }
 
     @Override
-    public void generate(World world, int baseChunkX, int baseChunkZ, ChunkGeneratorResult result)
-    {
-        int radius = radiusChunk;
-        rand.setSeed(world.getRandomSeed());
-        worldObj = world;
-        long randX = (this.rand.nextLong() / 2L) * 2L + 1L;
-        long randZ = (this.rand.nextLong() / 2L) * 2L + 1L;
-        for(int chunkX = baseChunkX - radius; chunkX <= baseChunkX + radius; chunkX++)
-        {
-            for(int chunkZ = baseChunkZ - radius; chunkZ <= baseChunkZ + radius; chunkZ++)
-            {
-                this.rand.setSeed((long)chunkX * randX + (long)chunkZ * randZ ^ world.getRandomSeed());
-                doGeneration(world, chunkX, chunkZ, baseChunkX, baseChunkZ, result);
+    public void generate(@NotNull World world, int baseChunkX, int baseChunkZ, @NotNull ChunkGeneratorResult result) {
+        int radius = getRadiusChunk();
+        Random rand = new Random(world.getRandomSeed());
+        long randX = (rand.nextLong() / 2L) * 2L + 1L;
+        long randZ = (rand.nextLong() / 2L) * 2L + 1L;
+        for (int chunkX = baseChunkX - radius; chunkX <= baseChunkX + radius; chunkX++) {
+            for (int chunkZ = baseChunkZ - radius; chunkZ <= baseChunkZ + radius; chunkZ++) {
+                rand.setSeed((long) chunkX * randX + (long) chunkZ * randZ ^ world.getRandomSeed());
+                doGeneration(world, rand, chunkX, chunkZ, baseChunkX, baseChunkZ, result);
             }
 
         }
     }
 
-    protected void generateHubRoom(int baseChunkX, int baseChunkZ, ChunkGeneratorResult result, double blockX, double blockY, double blockZ) {
-        generateCave(baseChunkX, baseChunkZ, result, blockX, blockY, blockZ, 1.0F + this.rand.nextFloat() * 6F, 0.0F, 0.0F, -1, -1, 0.5D);
+    protected void generateHubRoom(@NotNull World world, @NotNull Random random, int baseChunkX, int baseChunkZ, @NotNull ChunkGeneratorResult result, double blockX, double blockY, double blockZ) {
+        generateCave(world, random, baseChunkX, baseChunkZ, result, blockX, blockY, blockZ, 1.0F + random.nextFloat() * 6F, 0.0F, 0.0F, -1, -1, 0.5D);
     }
 
-    protected void generateCave(int baseChunkX, int baseChunkZ, ChunkGeneratorResult result, double blockX, double blockY,
+    protected void generateCave(@NotNull World world, @NotNull Random random, int baseChunkX, int baseChunkZ, @NotNull ChunkGeneratorResult result, double blockX, double blockY,
                                 double blockZ, float initialRadius, float yRot, float xRot, int startPos, int endPos,
                                 double heightMod) {
         double chunkMiddleX = baseChunkX * Chunk.CHUNK_SIZE_X + Chunk.CHUNK_SIZE_X / 2;
         double chunkMiddleZ = baseChunkZ * Chunk.CHUNK_SIZE_Z + Chunk.CHUNK_SIZE_Z / 2;
         float rotHorOffset = 0.0F;
         float rotVerOffset = 0.0F;
-        Random random = new Random(this.rand.nextLong());
+        Random r = new Random(random.nextLong());
         if (endPos <= 0) {
-            int maxLength = radiusChunk * 16 - 16;
-            endPos = maxLength - random.nextInt(maxLength / 4);
+            int maxLength = getRadiusChunk() * 16 - 16;
+            endPos = maxLength - r.nextInt(maxLength / 4);
         }
         boolean noBranches = false;
         if (startPos == -1) {
             startPos = endPos / 2;
             noBranches = true;
         }
-        int branchPos = random.nextInt(endPos / 2) + endPos / 4;
-        boolean sharpRotVer = random.nextInt(6) == 0;
+        int branchPos = r.nextInt(endPos / 2) + endPos / 4;
+        boolean sharpRotVer = r.nextInt(6) == 0;
         for (; startPos < endPos; startPos++) {
             double width = 1.5D + (MathHelper.sin((startPos * MathHelper.PI) / endPos) * initialRadius * 1.0F);
             double height = width * heightMod;
@@ -85,18 +80,18 @@ public class RetroCavesLargeFeature extends LargeFeature {
             yRot += rotHorOffset * 0.1F;
             rotVerOffset *= 0.9F;
             rotHorOffset *= 0.75F;
-            rotVerOffset += (random.nextFloat() - random.nextFloat()) * random.nextFloat() * 2.0F;
-            rotHorOffset += (random.nextFloat() - random.nextFloat()) * random.nextFloat() * 4F;
+            rotVerOffset += (r.nextFloat() - r.nextFloat()) * r.nextFloat() * 2.0F;
+            rotHorOffset += (r.nextFloat() - r.nextFloat()) * r.nextFloat() * 4F;
 
             // Do adjacent branches if necessary
             if (!noBranches && startPos == branchPos && initialRadius > 1.0F) {
-                generateCave(baseChunkX, baseChunkZ, result, blockX, blockY, blockZ, random.nextFloat() * 0.5F + 0.5F, yRot - MathHelper.PI / 2F, xRot / 3F, startPos, endPos, 1.0D);
-                generateCave(baseChunkX, baseChunkZ, result, blockX, blockY, blockZ, random.nextFloat() * 0.5F + 0.5F, yRot + MathHelper.PI / 2F, xRot / 3F, startPos, endPos, 1.0D);
+                generateCave(world, random, baseChunkX, baseChunkZ, result, blockX, blockY, blockZ, r.nextFloat() * 0.5F + 0.5F, yRot - MathHelper.PI / 2F, xRot / 3F, startPos, endPos, 1.0D);
+                generateCave(world, random, baseChunkX, baseChunkZ, result, blockX, blockY, blockZ, r.nextFloat() * 0.5F + 0.5F, yRot + MathHelper.PI / 2F, xRot / 3F, startPos, endPos, 1.0D);
                 return;
             }
 
             // Randomly skip a section
-            if (!noBranches && random.nextInt(4) == 0) {
+            if (!noBranches && r.nextInt(4) == 0) {
                 continue;
             }
 
@@ -139,7 +134,7 @@ public class RetroCavesLargeFeature extends LargeFeature {
             }
 
             // Check if we've hit the ocean, and if so, stop generating
-            if (worldObj.getWorldType().getOceanBlockId() != 0) {
+            if (world.getWorldType().getOceanBlockId() != 0) {
                 boolean hasHitOcean = false;
                 for (int x = minX; !hasHitOcean && x < maxX; x++) {
                     for (int z = minZ; !hasHitOcean && z < maxZ; z++) {
@@ -149,7 +144,7 @@ public class RetroCavesLargeFeature extends LargeFeature {
                             if (y < this.minY || y >= this.maxY) {
                                 continue;
                             }
-                            if (blockId == worldObj.getWorldType().getOceanBlockId()) {
+                            if (blockId == world.getWorldType().getOceanBlockId()) {
                                 hasHitOcean = true;
                             }
                             if (y != minY - 1 && x != minX && x != maxX - 1 && z != minZ && z != maxZ - 1) {
@@ -185,7 +180,7 @@ public class RetroCavesLargeFeature extends LargeFeature {
                                         result.setBlock(x, yIndex, z, 0);
 
                                         if (replaceTopBlock) {
-                                            Biome biome = worldObj.getBlockBiome(x, yIndex - 1, z);
+                                            Biome biome = world.getBlockBiome(x, yIndex - 1, z);
                                             int topBlockId = biome.topBlock;
                                             int fillBlockId = biome.fillerBlock;
                                             int id = result.getBlock(x, yIndex - 1, z);
@@ -210,29 +205,29 @@ public class RetroCavesLargeFeature extends LargeFeature {
     }
 
     @Override
-    protected void doGeneration(World world, int chunkX, int chunkZ, int baseChunkX, int baseChunkZ, ChunkGeneratorResult result) {
-        int cavesToGenerate = rand.nextInt(rand.nextInt(rand.nextInt(40) + 1) + 1);
-        if (this.rand.nextInt(15) != 0) {
+    protected void doGeneration(@NotNull World world, @NotNull Random random, int chunkX, int chunkZ, int baseChunkX, int baseChunkZ, @NotNull ChunkGeneratorResult result) {
+        int cavesToGenerate = random.nextInt(random.nextInt(random.nextInt(40) + 1) + 1);
+        if (random.nextInt(15) != 0) {
             cavesToGenerate = 0;
         }
 
-        final int yRange = maxY - minY;
+        final int yRange = this.maxY - this.minY;
 
         for (int i = 0; i < cavesToGenerate; i++) {
-            double blockX = chunkX * Chunk.CHUNK_SIZE_X + this.rand.nextInt(Chunk.CHUNK_SIZE_X);
-            double blockY = minY + this.rand.nextInt(this.rand.nextInt(yRange - (ChunkSection.SECTION_SIZE_Y / 2)) + (ChunkSection.SECTION_SIZE_Y / 2));
-            double blockZ = chunkZ * Chunk.CHUNK_SIZE_Z + this.rand.nextInt(Chunk.CHUNK_SIZE_Z);
+            double blockX = chunkX * Chunk.CHUNK_SIZE_X + random.nextInt(Chunk.CHUNK_SIZE_X);
+            double blockY = this.minY + random.nextInt(random.nextInt(yRange - (ChunkSection.SECTION_SIZE_Y / 2)) + (ChunkSection.SECTION_SIZE_Y / 2));
+            double blockZ = chunkZ * Chunk.CHUNK_SIZE_Z + random.nextInt(Chunk.CHUNK_SIZE_Z);
 
             int numBranches = 1;
-            if (rand.nextInt(4) == 0) {
-                generateHubRoom(baseChunkX, baseChunkZ, result, blockX, blockY, blockZ);
-                numBranches += rand.nextInt(4);
+            if (random.nextInt(4) == 0) {
+                generateHubRoom(world, random, baseChunkX, baseChunkZ, result, blockX, blockY, blockZ);
+                numBranches += random.nextInt(4);
             }
             for (int l1 = 0; l1 < numBranches; l1++) {
-                float yRot = this.rand.nextFloat() * MathHelper.PI * 2.0F; // 0 - 2Pi
-                float xRot = ((this.rand.nextFloat() - 0.5F) * 2.0F) / 8F; // -0.125 - 0.125
-                float initialRadius = this.rand.nextFloat() * 2.0F + this.rand.nextFloat(); // 0 - 3
-                generateCave(baseChunkX, baseChunkZ, result, blockX, blockY, blockZ, initialRadius, yRot, xRot, 0, 0, 1.0f);
+                float yRot = random.nextFloat() * MathHelper.PI * 2.0F; // 0 - 2Pi
+                float xRot = ((random.nextFloat() - 0.5F) * 2.0F) / 8F; // -0.125 - 0.125
+                float initialRadius = random.nextFloat() * 2.0F + random.nextFloat(); // 0 - 3
+                generateCave(world, random, baseChunkX, baseChunkZ, result, blockX, blockY, blockZ, initialRadius, yRot, xRot, 0, 0, 1.0f);
             }
         }
     }
